/**
 * Go SDK for OpenFGA
 *
 * API version: 0.1
 * Website: https://openfga.dev
 * Documentation: https://openfga.dev/docs
 * Support: https://discord.gg/8naAwJfWN6
 * License: [Apache-2.0](https://github.com/openfga/go-sdk/blob/main/LICENSE)
 *
 * NOTE: This file was auto generated by OpenAPI Generator (https://openapi-generator.tech). DO NOT EDIT.
 */

package openfga

import (
	"encoding/json"
)

// ListStoresResponse struct for ListStoresResponse
type ListStoresResponse struct {
	Stores            *[]Store `json:"stores,omitempty"`
	ContinuationToken *string  `json:"continuation_token,omitempty"`
}

// NewListStoresResponse instantiates a new ListStoresResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListStoresResponse() *ListStoresResponse {
	this := ListStoresResponse{}
	return &this
}

// NewListStoresResponseWithDefaults instantiates a new ListStoresResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListStoresResponseWithDefaults() *ListStoresResponse {
	this := ListStoresResponse{}
	return &this
}

// GetStores returns the Stores field value if set, zero value otherwise.
func (o *ListStoresResponse) GetStores() []Store {
	if o == nil || o.Stores == nil {
		var ret []Store
		return ret
	}
	return *o.Stores
}

// GetStoresOk returns a tuple with the Stores field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListStoresResponse) GetStoresOk() (*[]Store, bool) {
	if o == nil || o.Stores == nil {
		return nil, false
	}
	return o.Stores, true
}

// HasStores returns a boolean if a field has been set.
func (o *ListStoresResponse) HasStores() bool {
	if o != nil && o.Stores != nil {
		return true
	}

	return false
}

// SetStores gets a reference to the given []Store and assigns it to the Stores field.
func (o *ListStoresResponse) SetStores(v []Store) {
	o.Stores = &v
}

// GetContinuationToken returns the ContinuationToken field value if set, zero value otherwise.
func (o *ListStoresResponse) GetContinuationToken() string {
	if o == nil || o.ContinuationToken == nil {
		var ret string
		return ret
	}
	return *o.ContinuationToken
}

// GetContinuationTokenOk returns a tuple with the ContinuationToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListStoresResponse) GetContinuationTokenOk() (*string, bool) {
	if o == nil || o.ContinuationToken == nil {
		return nil, false
	}
	return o.ContinuationToken, true
}

// HasContinuationToken returns a boolean if a field has been set.
func (o *ListStoresResponse) HasContinuationToken() bool {
	if o != nil && o.ContinuationToken != nil {
		return true
	}

	return false
}

// SetContinuationToken gets a reference to the given string and assigns it to the ContinuationToken field.
func (o *ListStoresResponse) SetContinuationToken(v string) {
	o.ContinuationToken = &v
}

func (o ListStoresResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Stores != nil {
		toSerialize["stores"] = o.Stores
	}
	if o.ContinuationToken != nil {
		toSerialize["continuation_token"] = o.ContinuationToken
	}
	return json.Marshal(toSerialize)
}

type NullableListStoresResponse struct {
	value *ListStoresResponse
	isSet bool
}

func (v NullableListStoresResponse) Get() *ListStoresResponse {
	return v.value
}

func (v *NullableListStoresResponse) Set(val *ListStoresResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListStoresResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListStoresResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListStoresResponse(val *ListStoresResponse) *NullableListStoresResponse {
	return &NullableListStoresResponse{value: val, isSet: true}
}

func (v NullableListStoresResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListStoresResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
